import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { SwappableSettingsService } from '@multiversx/sdk-nestjs-common';
import { OptionsInterface } from './entities/options.interface';
export declare class RabbitPublisherService {
    private readonly amqpConnection;
    private readonly storageService?;
    private readonly options?;
    private readonly logger;
    constructor(amqpConnection: AmqpConnection, storageService?: SwappableSettingsService | undefined, options?: OptionsInterface | undefined);
    private generateDuplicateMessageKey;
    private isExchangeDisabled;
    private checkForDuplicatedMessages;
    invalidateDuplicateMessageKey(exchange: string, input: unknown): Promise<void>;
    publish(exchange: string, input: unknown, source?: string): Promise<void>;
}
