"use strict";
var RabbitModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.RabbitModule = void 0;
const tslib_1 = require("tslib");
const nestjs_rabbitmq_1 = require("@golevelup/nestjs-rabbitmq");
const common_1 = require("@nestjs/common");
const entities_1 = require("./entities");
const publisher_service_1 = require("./publisher.service");
const rabbit_context_checker_service_1 = require("./rabbit-context-checker.service");
const sdk_nestjs_common_1 = require("@multiversx/sdk-nestjs-common");
let RabbitModule = RabbitModule_1 = class RabbitModule {
    static forRoot(rabbitOptions, rabbitStorageSettings, auxOptions) {
        const imports = [nestjs_rabbitmq_1.RabbitMQModule.forRoot(nestjs_rabbitmq_1.RabbitMQModule, rabbitOptions)];
        const providers = [
            publisher_service_1.RabbitPublisherService,
            {
                provide: entities_1.RABBIT_ADDITIONAL_OPTIONS,
                useValue: auxOptions,
            },
        ];
        if (rabbitStorageSettings) {
            imports.push(sdk_nestjs_common_1.SwappableSettingsModule.forRoot(rabbitStorageSettings));
            providers.push(sdk_nestjs_common_1.SwappableSettingsService);
        }
        return {
            module: RabbitModule_1,
            global: true,
            imports,
            providers,
            exports: [publisher_service_1.RabbitPublisherService],
        };
    }
    static forRootAsync(rabbitAsyncOptions, rabbitAsyncStorageSettings, auxOptions) {
        const imports = [nestjs_rabbitmq_1.RabbitMQModule.forRootAsync(nestjs_rabbitmq_1.RabbitMQModule, rabbitAsyncOptions)];
        const providers = [
            publisher_service_1.RabbitPublisherService,
            {
                provide: entities_1.RABBIT_ADDITIONAL_OPTIONS,
                useValue: auxOptions,
            },
        ];
        if (rabbitAsyncStorageSettings) {
            imports.push(sdk_nestjs_common_1.SwappableSettingsModule.forRootAsync(rabbitAsyncStorageSettings));
            providers.push(sdk_nestjs_common_1.SwappableSettingsService);
        }
        return {
            module: RabbitModule_1,
            global: true,
            imports,
            providers,
            exports: [
                publisher_service_1.RabbitPublisherService,
                rabbit_context_checker_service_1.RabbitContextCheckerService,
            ],
        };
    }
};
RabbitModule = RabbitModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({
        providers: [rabbit_context_checker_service_1.RabbitContextCheckerService],
        exports: [rabbit_context_checker_service_1.RabbitContextCheckerService],
    })
], RabbitModule);
exports.RabbitModule = RabbitModule;
//# sourceMappingURL=rabbit.module.js.map